LinuxQMISDK: qaGobiApiPds.h File Reference

LinuxQMISDK SLQS03.03.07

- Main Page
- Modules
- References
- Data Structures

- File List
- Globals

Data Structures | Macros | Enumerations | Functions
qaGobiApiPds.h File Reference
Position Determination Service (PDS)

Position Determination Service API function prototypes. More...

Go to the source code of this file.

## Data Structures
struct | PDSPositionData
struct | GPSStateInfo

## Macros
#define | DEFAULTBYTEVALUE 0xFF
#define | DEFAULTWORDVALUE 0xFFFF
#define | DEFAULTLONGVALUE 0xFFFFFFFF

## Enumerations
enum | { eSetServiceAutomaticTrackingDisable =0, eSetServiceAutomaticTrackingEnable =1 }

## Functions
ULONG | GetPDSState (ULONG *pEnabledStatus, ULONG *pTrackingStatus)
ULONG | SetPDSState (ULONG enable)
ULONG | StartPDSTrackingSessionExt (BYTE sessionControl, BYTE sessionType, BYTE sessionOperation, BYTE sessionServerOption, BYTE fixTimeout, ULONG fixInterval, ULONG fixCount, ULONG fixAccuracy)
ULONG | StopPDSTrackingSession ()
ULONG | PDSInjectTimeReference (ULONGLONG systemTime, USHORT systemDiscontinuities)
ULONG | GetPDSDefaults (ULONG *pOperation, BYTE *pTimeout, ULONG *pInterval, ULONG *pAccuracy)
ULONG | SetPDSDefaults (ULONG operation, BYTE timeout, ULONG interval, ULONG accuracy)
ULONG | GetXTRAAutomaticDownload (ULONG *pbEnabled, USHORT *pInterval)
ULONG | SetXTRAAutomaticDownload (ULONG bEnabled, USHORT interval)
ULONG | GetXTRANetwork (ULONG *pPreference)
ULONG | SetXTRANetwork (ULONG preference)
ULONG | GetXTRAValidity (USHORT *pGPSWeek, USHORT *pGPSWeekOffset, USHORT *pDuration)
ULONG | ForceXTRADownload ()
ULONG | GetServiceAutomaticTracking (ULONG *pbAuto)
ULONG | SetServiceAutomaticTracking (ULONG bAuto)
ULONG | GetPortAutomaticTracking (ULONG *pbAuto)
ULONG | SetPortAutomaticTracking (ULONG bAuto)
ULONG | ResetPDSData (ULONG *pGPSDataMask, ULONG *pCellDataMask)
ULONG | SLQSSetAGPSConfig (ULONG *pServerAddress, ULONG *pServerPort, BYTE *pServerURL, BYTE *pServerURLLength, BYTE *pNetworkMode)
ULONG | SLQSPDSInjectAbsoluteTimeReference (ULONGLONG timeMsec, ULONG timeUncMsec, BYTE timeBase, BYTE forceFlag)
ULONG | SLQSGetAGPSConfig (ULONG *pServerAddress, ULONG *pServerPort, BYTE *pServerURL, BYTE *pServerURLLength, BYTE *pNetworkMode)
ULONG | SLQSPDSInjectPositionData (struct PDSPositionData *pPositionData)
ULONG | SLQSPDSDeterminePosition ()
ULONG | SLQSGetGPSStateInfo (GPSStateInfo *pGPSStateInfo)

## Detailed Description

Position Determination Service API function prototypes.

Copyright: © 2011-2014 Sierra Wireless, Inc. all rights reserved

## Macro Definition Documentation

#define DEFAULTBYTEVALUE 0xFF

#define DEFAULTLONGVALUE 0xFFFFFFFF

#define DEFAULTWORDVALUE 0xFFFF

## Enumeration Type Documentation

anonymous enum

Enumerator
eSetServiceAutomaticTrackingDisable |
eSetServiceAutomaticTrackingEnable |

## Function Documentation

ULONG ForceXTRADownload | ( |  | ) |

Forces the XTRA database to be downloaded to the device.

Parameters

  none |

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG GetPDSDefaults | ( | ULONG * | pOperation,
|  | BYTE * | pTimeout,
|  | ULONG * | pInterval,
|  | ULONG * | pAccuracy
| ) |  |

Returns the default tracking session configuration. The tracking session configuration is used when a tracking session is automatically started using SetServiceAutomaticTracking or due to the device detecting an application opening the NMEA port.

Parameters

  pOperation[OUT] | Current session operating mode 0 - Standalone 1 - MS based 2 - MS assisted
  pTimeout[OUT] | Maximum amount of time (seconds) to work on each fix, maximum is 255
  pInterval[OUT] | Interval (seconds) between fix requests
  pAccuracy[OUT] | Preferred accuracy threshold (meters)

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG GetPDSState | ( | ULONG * | pEnabledStatus,
|  | ULONG * | pTrackingStatus
| ) |  |

Returns the current PDS state.

Parameters

  pEnabledStatus[OUT] | Current PDS state 0 - disable 1 - enable
  pTrackingStatus[OUT] | Current PDS tracking session state Values: 0x00 - Unknown 0x01 - Inactive 0x02 - Active

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 seconds

ULONG GetPortAutomaticTracking | ( | ULONG * | pbAuto | ) |

Returns the automatic tracking configuration for the NMEA COM port.

Parameters

  pbAuto[OUT] | Automatic tracking enabled for NMEA COM port 0x00 - Disabled 0x01 - Enabled

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG GetServiceAutomaticTracking | ( | ULONG * | pbAuto | ) |

Returns the automatic tracking state for the service.

Parameters

  pbAuto[OUT] | Automatic tracking session started for service 0x00 - Disabled 0x01 - Enabled

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG GetXTRAAutomaticDownload | ( | ULONG * | pbEnabled,
|  | USHORT * | pInterval
| ) |  |

Returns the XTRA automatic database download configuration.

Parameters

  pbEnabled[OUT] | Automatic XTRA download status 0 - Disabled 1 - Enabled
  pInterval[OUT] | Interval (hours) between XTRA downloads

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG GetXTRANetwork | ( | ULONG * | pPreference | ) |

Returns the XTRA WWAN network preference. When automatic XTRA database downloading is enabled this preference determines which WWAN networks will be used to perform the XTRA database download.

Parameters

  pPreference[OUT] | XTRA WWAN network preference 0x00 - None (any available network) 0x01 - Home-only, only when on home systems 0x02 - Roam-only, only when on nonhome systems

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG GetXTRAValidity | ( | USHORT * | pGPSWeek,
|  | USHORT * | pGPSWeekOffset,
|  | USHORT * | pDuration
| ) |  |

Returns the XTRA database validity period. When automatic XTRA database downloading is enabled the validity period determines when the XTRA database will be updated through a new download.

Parameters

  pGPSWeek[OUT] | Starting GPS week of validity period
  pGPSWeekOffset[OUT] | Starting GPS week offset (minutes) of validity period
  pDuration[OUT] | Length of validity period (hours)

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG PDSInjectTimeReference | ( | ULONGLONG | systemTime,
|  | USHORT | systemDiscontinuities
| ) |  |

Injects a system time into the PDS engine.

Parameters

  systemTime | System time( milliseconds )
  systemDiscontinuities | Number of system time discontinuities

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG ResetPDSData | ( | ULONG * | pGPSDataMask,
|  | ULONG * | pCellDataMask
| ) |  |

Resets the specified PDS data.

Parameters

  pGPSDataMask[IN] | Bitmask of GPS data to clear (optional) 0x00000001 - EPH 0x00000002 - ALM 0x00000004 - POS 0x00000008 - TIME 0x00000010 - IONO 0x00000020 - UTC 0x00000040 - HEALTH 0x00000080 - SVDIR 0x00000100 - SVSTEER 0x00000200 - SADATA 0x00000400 - RTI 0x00000800 - ALM_CORR 0x00001000 - FREQ_BIAS_EST
  pCellDataMask[IN] | Bitmask of cell data to clear (optional) 0x00000001 - POS 0x00000002 - LATEST_GPS_POS 0x00000004 - OTA_POS 0x00000008 - EXT_REF_POS 0x00000010 - TIMETAG 0x00000020 - CELLID 0x00000040 - CACHED_CELLID 0x00000080 - LAST_SRV_CELL 0x00000100 - CUR_SRV_CELL 0x00000200 - NEIGHBOR_INFO

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG SetPDSDefaults | ( | ULONG | operation,
|  | BYTE | timeout,
|  | ULONG | interval,
|  | ULONG | accuracy
| ) |  |

Sets the default tracking session configuration. The tracking session configuration is used when a tracking session is automatically started using SetServiceAutomaticTracking or due to the device detecting an application opening the NMEA port.

Parameters

  operation | Current session operating mode 0 - Standalone 1 - MS based 2 - MS assisted
  timeout | Maximum amount of time (seconds) to work on each fix, maximum is 255
  interval | Interval (seconds) between fix requests
  accuracy | Preferred accuracy threshold (meters)

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG SetPDSState | ( | ULONG | enable | ) |

Sets the PDS state.

Parameters

  enable | Desired PDS state Zero - disable Non-Zero - enable

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 5 Seconds

ULONG SetPortAutomaticTracking | ( | ULONG | bAuto | ) |

Sets the automatic tracking configuration for the NMEA COM port.

Parameters

  bAuto | Enable automatic tracking for NMEA COM port 0x00 - Disabled 0x01 - Enabled

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG SetServiceAutomaticTracking | ( | ULONG | bAuto | ) |

Sets the automatic tracking state for the service. Tracking session being started using the default session configuration. Auto-tracking continues to generate fixes indefinitely until requested to be disabled. In StartPDSTrackingSessionExt a tracking session get started using the specified session control method and input parameters. After completion of requested no. of position fixes or service times out to perform fix, tracking session ends and GPS service deactivates.

Parameters

  bAuto | Automatic tracking session started for service 0x00 - Disabled 0x01 - Enabled

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG SetXTRAAutomaticDownload | ( | ULONG | bEnabled,
|  | USHORT | interval
| ) |  |

Sets the XTRA automatic database download configuration.

Parameters

  bEnabled | Automatic XTRA download status 0 - Disabled 1 - Enabled
  interval | Interval (hours) between XTRA downloads

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG SetXTRANetwork | ( | ULONG | preference | ) |

Sets the XTRA WWAN network preference. When automatic XTRA database downloading is enabled this preference determines which WWAN networks will be used to perform the XTRA database download.

Parameters

  preference | XTRA WWAN network preference 0x00 - None (any available network) 0x01 - Home-only, only when on home systems 0x02 - Roam-only, only when on non-home systems

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG SLQSGetAGPSConfig | ( | ULONG * | pServerAddress,
|  | ULONG * | pServerPort,
|  | BYTE * | pServerURL,
|  | BYTE * | pServerURLLength,
|  | BYTE * | pNetworkMode
| ) |  |

Gets the PDS AGPS (MS-based) configuration.

Parameters

  pServerAddress[OUT] | IPv4 address of AGPS server. "0" if not set
  pServerPort[OUT] | Port number of AGPS server. "0" if not set
  pServerURL[OUT] | URL of the AGPS server. "0" if not set
  pServerURLLength[OUT] | URL length of AGPS server. "0" if not set
  pNetworkMode[IN] | Network Mode of AGPS Server [optional - should be present in Multimode Systems] 0x00 - UMTS 0x01 - CDMA

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG SLQSGetGPSStateInfo | ( | GPSStateInfo * | pGPSStateInfo | ) |

Queries the MSM GPS server for receiver state information

Parameters

  pGPSStateInfo | contains the GPS State Info See GPSStateInfo for more information

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 5 Seconds

ULONG SLQSPDSDeterminePosition | ( |  | ) |

Requests the MSM GPS service to obtain the current position for manually controlled tracking sessions.

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 5 Seconds

ULONG SLQSPDSInjectAbsoluteTimeReference | ( | ULONGLONG | timeMsec,
|  | ULONG | timeUncMsec,
|  | BYTE | timeBase,
|  | BYTE | forceFlag
| ) |  |

Injects a absolute time reference into the PDS engine.

Parameters

  timeMsec | Represents the number of milliseconds elapsed since either a GPS or UTC time base. If the time base is UTC, this value should NOT include leap seconds
  timeUncMsec | Time uncertainty in milliseconds
  timeBase | Time base 0x00 - GPS (midnight, Jan 6, 1980) 0x01 - UTC (midnight, Jan 1, 1970)
  forceFlag | Force acceptance of data

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG SLQSPDSInjectPositionData | ( | struct PDSPositionData * | pPositionData | ) |

Injects position data into the PDS engine.

Parameters

  pPositionData | contains the position data to be injected to the PDS engine

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG SLQSSetAGPSConfig | ( | ULONG * | pServerAddress,
|  | ULONG * | pServerPort,
|  | BYTE * | pServerURL,
|  | BYTE * | pServerURLLength,
|  | BYTE * | pNetworkMode
| ) |  |

Sets the PDS AGPS (MS-based) configuration.

Parameters

  pServerAddress[IN] | IPv4 address of AGPS server [optional]
  pServerPort[IN] | Port number of AGPS server [optional - should be present when pServerAddress is present]
  pServerURL[IN] | URL of the AGPS server [optional]
  pServerURLLength[IN] | URL length of AGPS server [optional - should be present when pServerURL is present]
  pNetworkMode[IN] | Network Mode of AGPS Server [optional - should be present in Multimode Systems] 0x00 - UMTS 0x01 - CDMA

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG StartPDSTrackingSessionExt | ( | BYTE | sessionControl,
|  | BYTE | sessionType,
|  | BYTE | sessionOperation,
|  | BYTE | sessionServerOption,
|  | BYTE | fixTimeout,
|  | ULONG | fixInterval,
|  | ULONG | fixCount,
|  | ULONG | fixAccuracy
| ) |  |

This function starts a PDS tracking session.

Parameters

  sessionControl | Control method: 0x0 - Manual
  sessionType | Type: 0x0 - New
  sessionOperation | Operating mode: 0x00 - Standalone 0x01 - MS-based
  sessionServerOption | Location server option: 0x0 - Default
  fixTimeout | Maximum time to work on each fix (in seconds, max 255)
  fixCount | Count of position fix requests for this session (must be at least 1)
  fixTimeout | interval between position fix requests (in seconds)
  fixAccuracy | Preferred accuracy threshold(in meters)

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds

ULONG StopPDSTrackingSession | ( |  | ) |

This function stops a PDS tracking session.

Returns
  eQCWWAN_ERR_NONE on success, eQCWWAN_xxx error value otherwise

See Also
  See qmerrno.h for eQCWWAN_xxx error values

Note
  Timeout: 2 Seconds